#  ***** BEGIN LICENSE BLOCK *****  
#   
#  Source last modified: $Id: umake_win_vc9_makefile.py,v 1.2 2008/05/01 20:47:01 jfinnecy Exp $ 
#   
#  Copyright Notices: 
#   
#  Portions Copyright (c) 1995-2006 RealNetworks, Inc. All Rights Reserved. 
#   
#  Patent Notices: This file may contain technology protected by one or  
#  more of the patents listed at www.helixcommunity.org 
#   
#  1.   The contents of this file, and the files included with this file, 
#  are protected by copyright controlled by RealNetworks and its  
#  licensors, and made available by RealNetworks subject to the current  
#  version of the RealNetworks Public Source License (the "RPSL")  
#  available at  * http://www.helixcommunity.org/content/rpsl unless  
#  you have licensed the file under the current version of the  
#  RealNetworks Community Source License (the "RCSL") available at 
#  http://www.helixcommunity.org/content/rcsl, in which case the RCSL 
#  will apply.  You may also obtain the license terms directly from 
#  RealNetworks.  You may not use this file except in compliance with 
#  the RPSL or, if you have a valid RCSL with RealNetworks applicable 
#  to this file, the RCSL.  Please see the applicable RPSL or RCSL for 
#  the rights, obligations and limitations governing use of the 
#  contents of the file. 
#   
#  2.  Alternatively, the contents of this file may be used under the 
#  terms of the GNU General Public License Version 2 (the 
#  "GPL") in which case the provisions of the GPL are applicable 
#  instead of those above.  Please note that RealNetworks and its  
#  licensors disclaim any implied patent license under the GPL.   
#  If you wish to allow use of your version of this file only under  
#  the terms of the GPL, and not to allow others 
#  to use your version of this file under the terms of either the RPSL 
#  or RCSL, indicate your decision by deleting Paragraph 1 above 
#  and replace them with the notice and other provisions required by 
#  the GPL. If you do not delete Paragraph 1 above, a recipient may 
#  use your version of this file under the terms of any one of the 
#  RPSL, the RCSL or the GPL. 
#   
#  This file is part of the Helix DNA Technology.  RealNetworks is the 
#  developer of the Original Code and owns the copyrights in the 
#  portions it created.   Copying, including reproducing, storing,  
#  adapting or translating, any or all of this material other than  
#  pursuant to the license terms referred to above requires the prior  
#  written consent of RealNetworks and its licensors 
#   
#  This file, and the files included with this file, is distributed 
#  and made available by RealNetworks on an 'AS IS' basis, WITHOUT  
#  WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, AND REALNETWORKS  
#  AND ITS LICENSORS HEREBY DISCLAIM  ALL SUCH WARRANTIES, INCLUDING  
#  WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY, FITNESS  
#  FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT. 
#   
#  Technology Compatibility Kit Test Suite(s) Location:  
#     http://www.helixcommunity.org/content/tck 
#   
# Contributor(s):
#   This file was contributed by Christian Buchner
# 
# ***** END LICENSE BLOCK *****
# 
# 
""" Makefile generator which generates nmake files and VC9 SLN/VCPROJ files """

import os

import log
log.debug( 'Imported: $Id: umake_win_vc9_makefile.py,v 1.2 2008/05/01 20:47:01 jfinnecy Exp $' )

import umake_win_vc8_makefile
import umake_win_vc7_makefile
import umake_win_makefile

def make_makefile(platform, project):
    return umake_win_vc8_makefile.make_makefile(platform, project)

class VC9Workspace(umake_win_vc8_makefile.VC8Workspace):
    def __init__(self):
        umake_win_vc8_makefile.VC8Workspace.__init__(self)
        self.version = [
           'Microsoft Visual Studio Solution File, Format Version 10.00',
           '# Visual Studio 2008'
        ]
        
class VC9Project(umake_win_vc8_makefile.VC8Project):
    """Class representing and generating one MSDEV project"""

    def __init__(self, name, makefile_name, target_type, variables):
        umake_win_vc7_makefile.VC7Project.__init__(self, name, makefile_name, target_type, variables)
        self.projVersion = "9.00"
        
    def getXML(self):
        # vs VC8: adds TargetFrameworkVersion.
        xml = umake_win_vc8_makefile.xml
        return xml("VisualStudioProject",
                   { "ProjectType":"Visual C++",
                     "Version":"%s" % self.projVersion,
                     "Name":self.name,
                     "ProjectGUID":self.guid,
                     "Keyword":"MakeFileProj",
                     "TargetFrameworkVersion" : "131072", },
                   [ xml("Platforms", None,
                         [ xml("Platform",{ "Name":"Win32" } ) ] ),
                     xml("ToolFiles",{},[]),
                     xml("Configurations", {}, self.config_xml),
                     xml("References",{},[]),
                     xml("Files", {},
                         [ xml("Filter",
                               { "Name":"Source Files",
                                 "Filter":"cpp;c;cxx;def;odl;idl;hpj;bat;asm"
                                 },
                               self.file_xml),
                           xml("Filter",
                               { "Name":"Header Files",
                                 "Filter":"h;hpp;hxx;hm;inl;inc",
                                 },
                               self.header_xml),
                           xml("Filter",
                               { "Name":"Resource Files",
                                 "Filter":"rc;ico;cur;bmp;dlg;rc2;rct;bin;rgs;gif;jpg;jpeg;jpe",
                                 },
                               self.resource_xml)
                           ]),
                     xml("Globals",{},[]),
                     ])        

                     
umake_win_makefile._pGenerator = umake_win_vc7_makefile.VC7ProjectGenerator
umake_win_makefile._config     = umake_win_vc8_makefile.VC8Config
umake_win_makefile._project    = VC9Project
umake_win_makefile._workspace  = VC9Workspace


